.proc update_p1
  lda p1_speed_x
  cmp #$80
  bcc dirleft
  cmp #$81
  bcs dirright
  bcc check_jump_timer
dirright:
  lda #$00
  sta p1_dir
  beq check_jump_timer
dirleft:
  lda #$01
  sta p1_dir

check_jump_timer:
  lda p1_timer
  cmp #$00
  beq check_ground
  clc
  dec p1_timer        ; timer is active
  beq check_grav      ; timer reached 00
  bcc timer_normal    ; timer didn't pass 00
  lda #$00            ; timer passed 00
  sta p1_timer
timer_normal:
  lda pad1_a
  bne a_continue
  lda #$00
  sta p1_timer        ; do this so you can't jump twice
  jmp apply_grav

; CHECK GROUND //////////////////////////////////////////////

check_ground:
  lda p1_ground
  cmp #$1
  bne check_grav

; CHECK JUMP BUTTON //////////////////////////////////////////////

check_a:
  lda #$02
  sta p1_state

  lda pad1_a_pressed
  beq check_grav
a_pressed:
  lda #$01
  ldx #$00
  jsr FamiToneSfxPlay

  lda #PMAXJUMP
  sta p1_timer
a_continue:
  lda #$00
  sta p1_ground
  lda #PJUMP
  sta p1_speed_y  
  lda #$00
  sta p1_speed_y_high
  lda #$02
  sta p1_state

; APPLY GRAVITY //////////////////////////////////////////////

apply_grav:
  lda p1_y
  sec
  sbc p1_speed_y
  sta p1_y

; CHECK FLOOR REACHED //////////////////////////////////////////////

check_grav:
  lda p1_y
  cmp #GROUND
  bcs on_ground
on_air:
  lda p1_speed_y_high
  clc
  adc #GRAV
  sta p1_speed_y_high
  lda p1_speed_y
  sbc #$00
  sta p1_speed_y

  cmp #$00
  bne continue_air
spritefall:
  lda #$04
  sta p1_state

continue_air:
  lda p1_y
  sec
  sbc p1_speed_y
  sta p1_y
  clc
  cmp #GROUND
  bcc check_up
  lda #GROUND
  sta p1_y
  jmp check_up
on_ground:
  lda #$1
  sta p1_ground
  lda #$00
  sta p1_state
  lda #GROUND
  sta p1_y

; UP BUTTON //////////////////////////////////////////////

check_up:
  lda pad1_up
  cmp #$01

; DOWN BUTTON //////////////////////////////////////////////

check_down:
  lda pad1_down
  cmp #$01

; RIGHT BUTTON //////////////////////////////////////////////

check_right:
  lda pad1_right
  cmp #$01
  bne check_left
right_calc_speed:
  lda p1_speed_x_high
  clc
  adc #FRICTION
  sta p1_speed_x_high
  lda p1_speed_x
  ADC #$00
  sta p1_speed_x

  ;lda p1_speed_x
  ;clc
  ;adc #HORACCEL
  clc
  cmp #$82
  bcc right_continue
  lda #$82

right_continue:
  sta p1_speed_x
  sec
  sbc #$80
  tax
  clc
  adc p1_x
  sta p1_x
check_right_side:
  jmp checkscroll

; LEFT BUTTON //////////////////////////////////////////////

check_left:
  lda #$00
  sta scroll_x_spd
  lda pad1_left
  cmp #$01
  bne done_left
left_calc_speed:
  lda p1_speed_x_high
  sec
  sbc #FRICTION
  sta p1_speed_x_high
  lda p1_speed_x
  sbc #$00
  sta p1_speed_x

  ;lda p1_speed_x
  ;sec
  ;sbc #HORACCEL
  sec
  cmp #$7e
  bcs left_continue
  lda #$7e

left_continue:
  sta p1_speed_x
  sec
  sbc #$80
  clc
  adc p1_x
check_left_side:
  cmp #$04
  bcs ok_left
  lda #$80
  sta p1_speed_x
  lda #$00
  sta p1_speed_x_high
  lda #$04
ok_left:
  sta p1_x
  jmp exit

; INERTIA //////////////////////////////////////////////

done_left:        ; apply inertia here
  lda p1_speed_x
  cmp #$80
  beq exit
  bcc increase
decrease:
  sec
  sbc #$1
  jmp apply_intertia
increase:
  clc
  adc #$1
apply_intertia:
  sta p1_speed_x
  sec
  sbc #$80
  clc
  adc p1_x
  sta p1_x

checkscroll:
  cmp #$70
  bcc dontscroll
  ;bcs dontscroll ; use this to turn off scrolling by player movement

  lda #$02
  sta scroll_x_spd
  dec p1_x
  dec p1_x

  jmp exit
dontscroll:
  lda #$00
  sta scroll_x_spd
exit:
  
  lda p1_x
  sta spr_x
  lda p1_y
  sta spr_y

  lda p1_state
  clc
  adc p1_dir
  asl
  tax

  lda p1_metasprites,x
  sta animation_ptr
  lda p1_metasprites+1,x
  sta animation_ptr+1

  jmp buffer_priority ; only one character can use this
.endproc